//=============================================================================//
//  ___  ___   _   _   _    __   _   ___ ___ __ __
// |_ _|| __| / \ | \_/ |  / _| / \ | o \ o \\ V /
//  | | | _| | o || \_/ | ( |_n| o ||   /   / \ / 
//  |_| |___||_n_||_| |_|  \__/|_n_||_|\\_|\\ |_|  2006
//										 
//=============================================================================//

#include <windows.h>
#include "common/GMLuaModule.h"

#include <shellapi.h>
#include <winbase.h>

#pragma comment(lib,"shell32.lib")
#pragma comment(lib,"kernel32.lib")

// This is a macro to make life easier.
// When the dll is loaded it will call the function (Init)
GMOD_MODULE( Init, Shutdown );

/////////////////////////////////////////////////////////////////////////////////////////////
// FUNCTION DOCUMENTATION
//// SHELL EXECUTION
// Purpose: Allows the execution of commands, handy for remote rebooting, updating, etc
// ShellExec(File,Arguments,Running Directory) <- Executes a file
// ShellExecHidden(File,Arguments,Running Directory) <- Same as above but hides the window
// NOTE!! THIS FUNCTION WILL NOT WORK ON A CLIENT UNLESS YOU HAVE SET BlockClientShellExec

//////////////////////////////////////////////////////////////////////////////////////////
// DANGER DANGER DANGER!!!! DO NOT SET THIS TO FALSE UNLESS YOU KNOW WHAT YOU ARE DOING
// SETTING THIS FUNCTION TO FALSE WILL ALLOW ANYONE TO EXECUTE REMOTE COMMANDS ON YOUR 
// COMPUTER IF THEY KNOW YOU ARE RUNNING THIS LIBRARY!!!!
// THIS BLOCK IS IN PLACE TO DEAL WITH STUPID NEWBS WHO DON'T COMPILE CODE THEMSELVES
// THIS LIBRARY SHOULD COMPILE, STRAIGHT OUT OF THE BOX, IN A VANILLA 
// Microsoft Visual C++ 2008 Express Edition
// 
// YOU HAVE BEEN WARNED!
//////////////////////////////////////////////////////////////////////////////////////////
#define BlockClientShellExec true

//// General System Information

// function: GetDiskSpace(drive)
// Purpose: Returns current diskspace status, useful for busy build servers
// Args: drive <- This should be either a short letter (e.g. C), short drive ref (C:) 
// full drive ref (C:\) or a path (C:\some\path)
// Returns: Table, with following elements AppFreeSpace, HddTotal ,HddFree in Bytes

// function GetRAMStatus()
// Purpose: Returns status of the physical memory, handy for detecting mem faults and high
// server loads
// Args: None
// Returns: Table; MemoryUse, AvailablePhysical, TotalPhysical

// function GetUptime()
// Purpose: Returns number of seconds since boot, handy for bragging
// Args: none
// Returns: float, number of seconds since boot

/////////////////////////////////////////////////////////////////////////////////////////////
LUA_FUNCTION( ShellExec )
{
	if(g_Lua->IsDedicatedServer() == false && BlockClientShellExec == true)	
		return 0;

	LPCTSTR ShellExec_File = (LPCTSTR)g_Lua->GetString(1);
	LPCTSTR ShellExec_Args = (LPCTSTR)g_Lua->GetString(2);
	LPCTSTR ShellExec_Dir = (LPCTSTR)g_Lua->GetString(3);

	ShellExecute(NULL, NULL, ShellExec_File, NULL, NULL, SW_SHOWNORMAL);
	return 0;
}

LUA_FUNCTION( ShellExecHidden )
{
	if(g_Lua->IsDedicatedServer() == false && BlockClientShellExec == true) 
		return 0;

	LPCTSTR ShellExec_File = (LPCTSTR)g_Lua->GetString(1);
	LPCTSTR ShellExec_Args = (LPCTSTR)g_Lua->GetString(2);
	LPCTSTR ShellExec_Dir = (LPCTSTR)g_Lua->GetString(3);

	ShellExecute(NULL, NULL, ShellExec_File, NULL, NULL, SW_HIDE);
	return 0;
}

LUA_FUNCTION( GetDiskSpace )
{
	LPCTSTR GetDiskSpace_Drive = (LPCTSTR)g_Lua->GetString(1);

	ULARGE_INTEGER AppFreeSpace;
	ULARGE_INTEGER HddTotal;
	ULARGE_INTEGER HddFree;
		
	SHGetDiskFreeSpaceEx(GetDiskSpace_Drive, &AppFreeSpace, &HddTotal, &HddFree);
	
	
	ILuaObject * mytable = g_Lua->GetNewTable();


	float fAppFreeSpace = (float)AppFreeSpace.QuadPart;
	float fHddTotal = (float)HddTotal.QuadPart;
	float fHddFree = (float)HddFree.QuadPart;
	
	g_Lua->Push( fAppFreeSpace );
	g_Lua->SetMember( mytable, "AppFreeSpace" );

	g_Lua->Push( fHddFree );
	g_Lua->SetMember( mytable, "HddFree" );

	g_Lua->Push( fHddTotal );
	g_Lua->SetMember( mytable, "HddTotal" );

	g_Lua->Push(mytable);

	SAFE_UNREF( mytable );

	return 1;
}

LUA_FUNCTION( GetRAMStatus )
{

	ILuaObject * mytable = g_Lua->GetNewTable();

	MEMORYSTATUSEX statex;

	statex.dwLength = sizeof (statex);

	GlobalMemoryStatusEx (&statex);

	float AvailPhys = ((float)(statex.ullAvailPhys) / 1024);
	float TotalPhys = ((float)(statex.ullTotalPhys) / 1024);

	g_Lua->Push( (float)statex.dwMemoryLoad );
	g_Lua->SetMember( mytable, "MemoryUse" );

	g_Lua->Push( AvailPhys );
	g_Lua->SetMember( mytable, "AvailablePhysical" );

	g_Lua->Push( TotalPhys );
	g_Lua->SetMember( mytable, "TotalPhysical" );

	g_Lua->Push(mytable);

	SAFE_UNREF( mytable );

	return 1;
}

LUA_FUNCTION( GetUptime )
{
	ULONGLONG systemuptime = GetTickCount64();
	systemuptime = systemuptime / 1000; // Number of seconds uptime
	g_Lua->Push((float)systemuptime);
	return 1;
}

// When the DLL is initialized it will call this function to set itself up.
// It should be used to set up your library so it's all ready to go.
int Init( void )
{
	// Msg is defined in GMLuaModule.h
	// It's actually calling the Lua function, Msg
	Msg("[Binary Module] Shell Execute has been loaded\n");

	// Register our MsgBox function as a global
	//g_Lua->SetGlobal( "MsgBox", MsgBox );

	// Lets make a global table filled with functions (a module)
	g_Lua->NewGlobalTable( "shellexec" );
	ILuaObject* table = g_Lua->GetGlobal( "shellexec" );
		// Shell Execution
		table->SetMember( "ShellExec", ShellExec );
		table->SetMember( "ShellExecHidden", ShellExecHidden );
	
		// System Information
		table->SetMember( "GetDiskSpace", GetDiskSpace );
		table->SetMember( "GetUptime", GetUptime );
		table->SetMember( "GetRAMStatus",GetRAMStatus);

	// We're not deleting the table here - we're deleting the reference to it.
	// If you don't do this you're leaking memory.
	SAFE_UNREF( table );

	return 0;
}

// When the DLL is shutdown it calls this function.
// g_Lua should be assumed to have been released here
int Shutdown( void )
{
	
	return 0;
}

